/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.17
 */

#include "sipAPIlibrviz_sip.h"

#line 7 "tool_manager.sip"
#define ROS_PACKAGE_NAME "rviz"
#include <rviz/tool_manager.h>
#line 13 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"

#line 7 "tool.sip"
#define ROS_PACKAGE_NAME "rviz"
#include <rviz/tool.h>
#line 18 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 34 "/usr/share/sip/PyQt5/QtCore/qstringlist.sip"
#include <qstringlist.h>
#line 21 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 27 "/usr/share/sip/PyQt5/QtCore/qstring.sip"
#include <qstring.h>
#line 24 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 7 "config.sip"
#define ROS_PACKAGE_NAME "rviz"
#include <rviz/config.h>
#line 28 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qmetaobject.sip"
#include <qmetaobject.h>
#line 31 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 34 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 244 "/usr/share/sip/PyQt5/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 37 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 232 "/usr/share/sip/PyQt5/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 40 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 28 "/usr/share/sip/PyQt5/QtCore/qobject.sip"
#include <qobject.h>
#line 43 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qvariant.sip"
#include <qvariant.h>
#line 46 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 36 "/usr/share/sip/PyQt5/QtCore/qpycore_qlist.sip"
#include <qlist.h>
#line 49 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 32 "/usr/share/sip/PyQt5/QtCore/qbytearray.sip"
#include <qbytearray.h>
#line 52 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 144 "/usr/share/sip/PyQt5/QtCore/qpycore_qlist.sip"
#include <qlist.h>
#line 55 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 58 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qthread.sip"
#include <qthread.h>
#line 61 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 64 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qregexp.sip"
#include <qregexp.h>
#line 67 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qregularexpression.sip"
#include <qregularexpression.h>
#line 70 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"
#line 26 "/usr/share/sip/PyQt5/QtCore/qobjectdefs.sip"
#include <qobjectdefs.h>
#line 73 "/home/eaibot/2022_jsjds/dashgo_ws/devel/bin/sip/rviz_sip/siplibrviz_siprvizToolManager.cpp"


extern "C" {static PyObject *meth_rviz_ToolManager_initialize(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_initialize(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_rviz_ToolManager, &sipCpp))
        {
            sipCpp->initialize();

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_initialize, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_load(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_load(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;
    bool sipSelfWasArg = (!sipSelf || sipIsDerived((sipSimpleWrapper *)sipSelf));

    {
        const rviz::Config* a0;
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ9", &sipSelf, sipType_rviz_ToolManager, &sipCpp, sipType_rviz_Config, &a0))
        {
            (sipSelfWasArg ? sipCpp->rviz::ToolManager::load(*a0) : sipCpp->load(*a0));

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_load, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_save(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_save(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;
    bool sipSelfWasArg = (!sipSelf || sipIsDerived((sipSimpleWrapper *)sipSelf));

    {
        rviz::Config* a0;
        const rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ9", &sipSelf, sipType_rviz_ToolManager, &sipCpp, sipType_rviz_Config, &a0))
        {
            (sipSelfWasArg ? sipCpp->rviz::ToolManager::save(*a0) : sipCpp->save(*a0));

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_save, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_addTool(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_addTool(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString* a0;
        int a0State = 0;
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_rviz_ToolManager, &sipCpp, sipType_QString,&a0, &a0State))
        {
            rviz::Tool*sipRes;

            sipRes = sipCpp->addTool(*a0);
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_rviz_Tool,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_addTool, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_getCurrentTool(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_getCurrentTool(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_rviz_ToolManager, &sipCpp))
        {
            rviz::Tool*sipRes;

            sipRes = sipCpp->getCurrentTool();

            return sipConvertFromType(sipRes,sipType_rviz_Tool,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_getCurrentTool, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_getTool(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_getTool(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_rviz_ToolManager, &sipCpp, &a0))
        {
            rviz::Tool*sipRes;

            sipRes = sipCpp->getTool(a0);

            return sipConvertFromType(sipRes,sipType_rviz_Tool,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_getTool, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_numTools(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_numTools(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_rviz_ToolManager, &sipCpp))
        {
            int sipRes;

            sipRes = sipCpp->numTools();

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_numTools, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_removeTool(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_removeTool(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_rviz_ToolManager, &sipCpp, &a0))
        {
            sipCpp->removeTool(a0);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_removeTool, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_removeAll(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_removeAll(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_rviz_ToolManager, &sipCpp))
        {
            sipCpp->removeAll();

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_removeAll, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_setCurrentTool(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_setCurrentTool(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        rviz::Tool* a0;
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_rviz_ToolManager, &sipCpp, sipType_rviz_Tool, &a0))
        {
            sipCpp->setCurrentTool(a0);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_setCurrentTool, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_setDefaultTool(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_setDefaultTool(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        rviz::Tool* a0;
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_rviz_ToolManager, &sipCpp, sipType_rviz_Tool, &a0))
        {
            sipCpp->setDefaultTool(a0);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_setDefaultTool, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_getDefaultTool(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_getDefaultTool(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_rviz_ToolManager, &sipCpp))
        {
            rviz::Tool*sipRes;

            sipRes = sipCpp->getDefaultTool();

            return sipConvertFromType(sipRes,sipType_rviz_Tool,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_getDefaultTool, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_rviz_ToolManager_getToolClasses(PyObject *, PyObject *);}
static PyObject *meth_rviz_ToolManager_getToolClasses(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        rviz::ToolManager *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_rviz_ToolManager, &sipCpp))
        {
            QStringList*sipRes;

            sipRes = new QStringList(sipCpp->getToolClasses());

            return sipConvertFromNewType(sipRes,sipType_QStringList,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolManager, sipName_getToolClasses, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_rviz_ToolManager(void *, const sipTypeDef *);}
static void *cast_rviz_ToolManager(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_rviz_ToolManager)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_QObject)->ctd_cast((QObject *)(rviz::ToolManager *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_rviz_ToolManager(void *, int);}
static void release_rviz_ToolManager(void *sipCppV,int)
{
    rviz::ToolManager *sipCpp = reinterpret_cast<rviz::ToolManager *>(sipCppV);

    if (QThread::currentThread() == sipCpp->thread())
        delete sipCpp;
    else
        sipCpp->deleteLater();
}


extern "C" {static void dealloc_rviz_ToolManager(sipSimpleWrapper *);}
static void dealloc_rviz_ToolManager(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_rviz_ToolManager(sipGetAddress(sipSelf),0);
    }
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_rviz_ToolManager[] = {{163, 0, 1}};


static PyMethodDef methods_rviz_ToolManager[] = {
    {SIP_MLNAME_CAST(sipName_addTool), meth_rviz_ToolManager_addTool, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_getCurrentTool), meth_rviz_ToolManager_getCurrentTool, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_getDefaultTool), meth_rviz_ToolManager_getDefaultTool, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_getTool), meth_rviz_ToolManager_getTool, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_getToolClasses), meth_rviz_ToolManager_getToolClasses, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_initialize), meth_rviz_ToolManager_initialize, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_load), meth_rviz_ToolManager_load, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_numTools), meth_rviz_ToolManager_numTools, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_removeAll), meth_rviz_ToolManager_removeAll, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_removeTool), meth_rviz_ToolManager_removeTool, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_save), meth_rviz_ToolManager_save, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCurrentTool), meth_rviz_ToolManager_setCurrentTool, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setDefaultTool), meth_rviz_ToolManager_setDefaultTool, METH_VARARGS, NULL}
};


/* Define this type's signals. */
static const pyqt5QtSignal signals_rviz_ToolManager[] = {
    {"toolRemoved(rviz::Tool*)", 0, 0, 0},
    {"toolChanged(rviz::Tool*)", 0, 0, 0},
    {"toolAdded(rviz::Tool*)", 0, 0, 0},
    {"configChanged()", 0, 0, 0},
    {0, 0, 0, 0}
};


pyqt5ClassTypeDef sipTypeDef_librviz_sip_rviz_ToolManager = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_rviz__ToolManager,
        {0}
    },
    {
        sipNameNr_ToolManager,
        {0, 255, 0},
        13, methods_rviz_ToolManager,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_rviz_ToolManager,
    0,
    0,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_rviz_ToolManager,
    0,
    0,
    0,
    release_rviz_ToolManager,
    cast_rviz_ToolManager,
    0,
    0,
    0,
    0,
    0,
    0
},
    &rviz::ToolManager::staticMetaObject,
    0,
    signals_rviz_ToolManager,
    0
};
